// 使用封装为支持异步的 IndexedDB
import { openDB, deleteDB, wrap, unwrap } from 'idb'
const storenames = ['music', 'chat', 'user']
const database = await openDB('database', 1, {
    upgrade(db) {
        storenames.forEach(name => db.createObjectStore(name, { keyPath: 'id' }))
        console.log('store created:', storenames)
    }
})

export class Store {
    constructor(data) {
        this.name = data.name
        this.info = data.info
    }

    create(data) {
        const id = window.crypto.randomUUID()
        return { id, ...data }
    }

    delete(id) {}

    query() {}
}

export const musicStore = new Store({
    name: '音乐(资源类型)',
    info: '音乐(类型说明)',
    存储时间: 1000 * 60 * 60 * 24 * 7, // 7天不使用的资源将被删除
    list: [{
        id: 'uuid',
        name: 'Dear big sisterremix ver.mp3',
        arrayBuffer: 'ArrayBuffer',
        createdAt: 1580000000000,  // 创建时间
        updatedAt: 1580000000000,  // 更新时间
        lastUsedAt: 1580000000000, // 最后使用时间
    }]
})

export const chatStore = new Store({
    name: '聊天(资源类型)',
    info: '聊天(类型说明)',
    存储时间: 1000 * 60 * 60 * 24 * 7, // 7天不使用的资源将被删除
    list: [{
        id: 'uuid',
        name: 'Dear big sisterremix ver.mp3',
        arrayBuffer: 'ArrayBuffer',
        createdAt: 1580000000000,  // 创建时间
        updatedAt: 1580000000000,  // 更新时间
        lastUsedAt: 1580000000000, // 最后使用时间
    }]
})
